package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseOffrSectRltnIfscRepository;
import com.its.op.dto.its.rse.TbRseOffrSectRltnIfscDto;
import com.its.op.entity.its.rse.TbRseOffrSectRltnIfsc;
import com.its.op.entity.its.rse.TbRseOffrSectRltnIfscKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseOffrSectRltnIfscService {

    private final TbRseOffrSectRltnIfscRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseOffrSectRltnIfsc requireOne(TbRseOffrSectRltnIfscKey id) throws NoSuchElementException {
        Optional<TbRseOffrSectRltnIfsc> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseOffrSectRltnIfscDto> findAll() {
        List<TbRseOffrSectRltnIfscDto> result = new ArrayList<>();
        List<TbRseOffrSectRltnIfsc> data = this.repo.findAll();
        for (TbRseOffrSectRltnIfsc entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRseOffrSectRltnIfscDto findById(TbRseOffrSectRltnIfscKey id) {
        TbRseOffrSectRltnIfsc entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbRseOffrSectRltnIfscDto updateById(TbRseOffrSectRltnIfscKey id, TbRseOffrSectRltnIfscDto.TbRseOffrSectRltnIfscUpdReq req) {
        TbRseOffrSectRltnIfsc entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbRseOffrSectRltnIfscDto> mergeInfoList(List<TbRseOffrSectRltnIfscDto.TbRseOffrSectRltnIfscUpdReq> reqList) {
        List<TbRseOffrSectRltnIfscDto> result = new ArrayList<>();
        for (TbRseOffrSectRltnIfscDto.TbRseOffrSectRltnIfscUpdReq req : reqList) {
            TbRseOffrSectRltnIfsc obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbRseOffrSectRltnIfscDto mergeInfo(TbRseOffrSectRltnIfscDto.TbRseOffrSectRltnIfscUpdReq req) {
        TbRseOffrSectRltnIfsc obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbRseOffrSectRltnIfscDto deleteById(TbRseOffrSectRltnIfscKey id) {
        TbRseOffrSectRltnIfsc entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbRseOffrSectRltnIfscDto> deleteByIds(List<TbRseOffrSectRltnIfscKey> ids) {
        List<TbRseOffrSectRltnIfscDto> result = new ArrayList<>();
        for (TbRseOffrSectRltnIfscKey id : ids) {
            Optional<TbRseOffrSectRltnIfsc> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
